Subject: Re: [X2Go-Dev] Bug#1369: Bug#1369: Keys do not release when using Emacs in X2GO Client

From: "Andreas Ehliar - Emacs related" <[email-masked]>
Date: Thu, 14 Jan 2021 16:41:10 +0000

I may have found a hint of the root cause of this bug (tested with emacs 27.1).
I believe that it is related to clipboard updating. If I disable clipboard updating from emacs the stuck key behavior goes away.
Note that for every line that we widen the selection in emacs the clipboard is automatically updated. (I proved this by repeatedly pressing ctrl-v in notepadwhile emacs exhibited the stuck key behavior and each time the pasted text grew.)
If it turns out that emacs and/or x2go prioritizes clipboard updates before key-up events we may end up in a race where the clipboard takes longer to update than it takes emacs to scroll the cursor one line and enlarge the clipboard even further.
To play around with this you can redefine the gui-set-selection function as a nop in emacs to disable the updating. (This is not a workaround though since it completely disables copying from an emacs window. A better work-around may be to add some sort of rate-limit to this function but I haven't played around with that yet.)
(defun gui-set-selection (type data))
/Andreas